import datetime as dt
from emitime.conversion import Number
from plum.type import Union
from typing import Union as tUnion

LikeInterval = Union[str, dt.timedelta, dt.time, IntervalType]
LikeMoment = Union[str, dt.date, dt.datetime, MomentType]

class Interval:
    def __init__(self, *args, **kwargs) -> None: ...
    @property
    def timedelta(self) -> dt.timedelta: ...
    @timedelta.setter
    def timedelta(self, value: LikeInterval) -> None: ...
    def __add__(self, other: Union['Interval', 'Moment']) -> Union['Interval', 'Moment']: ...
    def __radd__(self, other: Union['Interval', 'Moment']) -> Union['Interval', 'Moment']: ...
    def __sub__(self, other: LikeInterval) -> Interval: ...
    def __rsub__(self, other: tUnion['LikeInterval', 'LikeMoment']) -> tUnion['Interval', 'Moment']: ...
    def __mul__(self, other: Number) -> Interval: ...
    def __rmul__(self, other: Number) -> Interval: ...
    def __floordiv__(self, other: LikeInterval) -> int: ...
    def __mod__(self, other: LikeInterval) -> Interval: ...
    def __lt__(self, other: LikeInterval) -> bool: ...
    def __le__(self, other: LikeInterval) -> bool: ...
    def __eq__(self, other: LikeInterval) -> bool: ...
    def __gt__(self, other: LikeInterval) -> bool: ...
    def __ge__(self, other: LikeInterval) -> bool: ...
    def __float__(self) -> float: ...
    def __hash__(self) -> int: ...

class Moment:
    def __init__(self, *args, **kwargs) -> None: ...
    @property
    def datetime(self) -> dt.datetime: ...
    @datetime.setter
    def datetime(self, value: LikeMoment) -> None: ...
    @property
    def date(self) -> dt.date: ...
    @date.setter
    def date(self, value: dt.date) -> None: ...
    @date.setter
    def date(self, value: str) -> None: ...
    @property
    def time(self) -> dt.time: ...
    @time.setter
    def time(self, value: dt.time) -> None: ...
    @time.setter
    def time(self, value: str) -> None: ...
    def __sub__(self, other: tUnion['LikeInterval', 'LikeMoment']) -> tUnion['Interval', 'Moment']: ...
    def __rsub__(self, other: LikeMoment) -> Interval: ...
    def __add__(self, other: LikeInterval) -> Moment: ...
    def __radd__(self, other: LikeInterval) -> Moment: ...
    def __lt__(self, other: LikeMoment) -> bool: ...
    def __le__(self, other: LikeMoment) -> bool: ...
    def __eq__(self, other: LikeMoment) -> bool: ...
    def __gt__(self, other: LikeMoment) -> bool: ...
    def __ge__(self, other: LikeMoment) -> bool: ...
    def __float__(self) -> float: ...
    def __hash__(self) -> int: ...
